;the Nibbles game by Stilgar
;see the Readme file for more information
;compatible with Fargo II and rom 2.1 (modifications by G.Queri <gqueri@mail.dotcom.fr>)

	include "tios.h"
	include "flib.h"
	xdef _main
	xdef _comment

;20*30

WriteStr	macro
	move.w	\3,-(a7)
	pea 	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr 	tios::DrawStrXY
	lea	10(a7),a7
	endm

SetFont	macro
	move.w	\1,-(a7)
	jsr 	tios::FontSetSys
	lea 	2(a7),a7
	endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;waits for key and returns in d0
getkey:
	tst.w	(tios::kb_vars+$1E)
	beq	getkey
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;waits for space
waitspace:
\loop:	tst.w	(tios::kb_vars+$1C)
	beq	\loop
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#32,d0
	beq	\space
	cmp.w	#$108,d0
	bne	\loop

\esc:	clr.w	jack_lives
	move.w	#1,jack_dead

\space:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;clear screen
clrscr:	
	move.l	#tios::main_lcd,a0
	move.w	#959,d0
\loop:	clr.l	(a0)+
	dbf.w	d0,\loop
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;arguments : (d1,d2), put if d3 else clear
put_block:
	movem.l	d1-d2/a0,-(a7)
	move.l	#tios::main_lcd,a0

	mulu.w	#6*30,d2
	add.w	d1,d2				;y*6*30 + x
	
	adda.w	d2,a0

	move.w	#5,d1
\loop:	move.b	d3,(a0)
	lea	30(a0),a0
	dbf.w	d1,\loop

	movem.l	(a7)+,d1-d2/a0
	rts		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;creates new bonus
create_bonus:
	move.w	#28,d0
	jsr	flib::random
	add.w	#1,d0
	move.w	d0,bonusx

	move.w	#18,d0
	jsr	flib::random
	add.w	#1,d0
	move.w	d0,bonusy

	move.w	bonusx,d1
	move.w	bonusy,d2
	
	bsr	in_jack
	tst.w	d0
	bne	create_bonus

	mulu.w	#30,d2
	add.w	d1,d2
	move.l	buffer,a0
	adda.w	d2,a0
	tst.b	(a0)
	bne	create_bonus
	
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;draws bonus
put_bonus:
	movem.l	d1-d2/a0,-(a7)
	move.l	#tios::main_lcd,a0

	move.w	bonusy,d2
	mulu.w	#6*30,d2
	add.w	bonusx,d2			;y*6*30 + x
	
	adda.w	d2,a0

	move.w	#%1010101010101010,d3
	move.w	#5,d1
\loop:	move.b	d3,(a0)
	lea	30(a0),a0
	lsr.w	#1,d3
	dbf.w	d1,\loop

	movem.l	(a7)+,d1-d2/a0
	rts		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;init jack !
init_jack:
	clr.w	jack_dead
	move.w	#3,jack_len
	move.w	#3,jack_goal
	move.w	#3,jack_dir
	lea	jackx(pc),a0
	lea	jacky(pc),a1
	move.b	#5,(a0)+
	move.b	#4,(a0)+
	move.b	#3,(a0)+
	move.b	#2,(a0)+
	move.b	#3,(a1)+
	move.b	#3,(a1)+
	move.b	#3,(a1)+
	move.b	#3,(a1)+
	clr.b	(a0)
	clr.b	(a1)

	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;loads level into buffer
load_level:
	lea	level_data(pc),a0
	move.w	level,d3
	mulu.w	#20*4,d3
	adda.w	d3,a0

	move.l	buffer,a1

	move.w	#19,d2

\loopy:	move.l	(a0)+,d0
	clr.w	d1

\loopb:	clr.b	d3
	lsr.l	#1,d0
	bcc.s	\skip
	move.b	#$ff,d3
\skip:	move.b	d3,(a1)+

	add.w	#1,d1
	cmp.w	#30,d1
	bne	\loopb
	
	dbf.w	d2,\loopy

	add.w	#1,jack_lives
	add.w	#1,level

	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
display_buffer:
	move.l	buffer,a0

	clr.w	d2

\loopy:	clr.w	d1
\loopx:	move.b	(a0)+,d3
	bsr	put_block
	add.w	#1,d1
	cmp.w	#30,d1
	bne	\loopx
	
	add.w	#1,d2
	cmp.w	#20,d2
	bne	\loopy

	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;returns 1 in d0 if (d1,d2) is in jack
in_jack:
	movem.l	d1-d4/a0,-(a7)

	move.w	#1,d0
	lea	jackx(pc),a0
	lea	jacky(pc),a1
	
	move.w	jack_len,d3
\loop:	move.b	(a0)+,d4
	ext.w	d4
	cmp.w	d4,d1
	bne	\skip
	move.b	(a1),d4
	ext.w	d4
	cmp.w	d4,d2
	beq	\hit
\skip:	adda.w	#1,a1
	dbf.w	d3,\loop
	clr.w	d0
\hit:	movem.l	(a7)+,d1-d4/a0
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;draws snake
draw_jack:
	lea	jackx(pc),a0
	lea	jacky(pc),a1

	move.w	jack_len,d4
	sub.w	#1,d4
	beq	\end

	move.b	#$ff,d3
\loop:	move.b	(a0)+,d1
	ext.w	d1
	move.b	(a1)+,d2
	ext.w	d2

	tst.w	d1
	beq	\end
	tst.w	d2
	beq	\end

	bsr	put_block
	dbf.w	d4,\loop

	move.b	(a0),d1
	move.b	(a1),d2
	clr.b	d3
	bsr	put_block

\end:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;moves Jack through the screen
move_jack:
	move.w	jack_len,d3
	cmp.w	jack_goal,d3
	bge	\skip2
	add.w	#1,jack_len
	move.w	jack_len,d3
\skip2:	

	lea	jackx(pc),a0
	adda.w	d3,a0
	lea	jacky(pc),a1
	adda.w	d3,a1

\loop1:	move.b	(a0),1(a0)
	move.b	(a1),1(a1)
	suba.w	#1,a0
	suba.w	#1,a1
	dbf.w	d3,\loop1

	lea	jackx(pc),a0
	lea	jacky(pc),a1

	move.w	jack_dir,d0
	tst.w	d0
	beq	\up
	sub.w	#1,d0
	beq	\down
	sub.w	#1,d0
	beq	\left
	bra	\right
	
\up:	move.b	1(a0),(a0)
	move.b	1(a1),d0
	sub.b	#1,d0
	move.b	d0,(a1)
	bra	\skip
\down:	move.b	1(a0),(a0)
	move.b	1(a1),d0
	add.b	#1,d0
	move.b	d0,(a1)
	bra	\skip
\left:	move.b	1(a1),(a1)
	move.b	1(a0),d0
	sub.b	#1,d0
	move.b	d0,(a0)
	bra	\skip
\right:	move.b	1(a1),(a1)
	move.b	1(a0),d0
	add.b	#1,d0
	move.b	d0,(a0)

\skip:	
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;checks if jack is itself in a wall or bonus
;return d0 = 1 if bonus found
check_jack:
	lea	jackx(pc),a0
	lea	jacky(pc),a1

	move.b	(a0)+,d1
	move.b	(a1)+,d2
	move.w	jack_len,d3
	sub.w	#1,d3
	
\loop1:	cmp.b	(a1)+,d2
	bne	\skip1
	cmp.b	(a0),d1
	beq	\dead
\skip1:	adda.w	#1,a0
	dbf.w	d3,\loop1

	lea	jackx(pc),a0
	lea	jacky(pc),a1

	move.b	(a0),d1
	ext.w	d1
	move.b	(a1),d2
	ext.w	d2
	
	cmp.w	bonusx,d1
	bne	\skip
	cmp.w	bonusy,d2
	beq	\bonus

\skip:	mulu.w	#30,d2
	add.w	d1,d2
	move.l	buffer,a0
	adda.w	d2,a0
	tst.b	(a0)
	beq.s	\alive
\dead:	move.w	#1,jack_dead
\alive:	clr.w	d0
	rts

\bonus:	move.w	#1,d0
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; alloc screen buffer
init:	move.l	#610,-(a7)
	jsr	tios::HeapAlloc
	lea	4(a7),a7
	
	tst.w	d0
	beq	\error

	move.w	d0,bhandle
	tios::DEREF d0,a0
	move.l	a0,buffer

\error:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
exit:	move.w	bhandle,-(a7)
	jsr	tios::HeapFree
	lea	2(a7),a7
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;asks speed
config:
	bsr	clrscr
	SetFont	#1
	WriteStr #1,#1,#1,m_title
	WriteStr #10,#40,#1,m_howtough
	WriteStr #110,#50,#1,m_question

        SetFont #0
        WriteStr #80,#120,#1,m_title2
        SetFont #1

\wrong:	bsr	getkey
	cmp.w	#'0',d0
	blt	\wrong
	cmp.w	#'9',d0
	bgt	\wrong

	sub.w	#'0',d0
	mulu.w	#$800,d0
	move.w	#$5000,d3
	sub.w	d0,d3
	move.w	d3,delay

	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;displays lives that remains
disp_lives:
	move.l	#tios::main_lcd,a0
	adda.w	#30*122,a0

	move.b	#%01111110,d0	
	move.w	jack_lives,d3
	tst.w	d3
	beq	\skip1
	cmp.w	#10,d3	
	blt	\skip
	move.w	#10,d3	
\skip:	move.w	#11,d4
	sub.w	d3,d4

\loop1:	move.b	d0,(a0)
	move.b	d0,30(a0)
	adda.w	#1,a0
	sub.w	#1,d3
	bne	\loop1

	clr.b	d0
\loop2:	move.b	d0,(a0)
	move.b	d0,30(a0)
	adda.w	#1,a0
	dbf.w	d4,\loop2

	rts	

\skip1:	move.w	#11,d4
	clr.b	d0
	bra	\loop2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
disp_remaining:
	move.l	#tios::main_lcd,a0
	adda.w	#30*125,a0

	move.b	#%01111110,d0	
	move.w	bonus_left,d3
	sub.w	#1,d3
	cmp.w	#10,d3	
	blt	\skip
	move.w	#10,d3	
\skip:	move.w	#12,d4
	sub.w	d3,d4

\loop1:	move.b	d0,(a0)
	move.b	d0,30(a0)
	adda.w	#1,a0
	dbf.w	d3,\loop1

	clr.b	d0
\loop2:	move.b	d0,(a0)
	move.b	d0,30(a0)
	adda.w	#1,a0
	dbf.w	d4,\loop2

	rts	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_main:
	bsr	init
	tst.w	d0
	beq	\error

	clr.w	level
	move.w	#4,jack_lives
	clr.w	jack_cheat
	bsr	config

\loop1:	bsr	clrscr
	bsr	load_level

\loop2:	move.w	#11,bonus_left
	bsr	disp_lives
	bsr	init_jack
	bsr	display_buffer

	bsr	disp_remaining
	bsr	create_bonus
	bsr	put_bonus
	bsr	draw_jack
	bsr	waitspace

\loop:	bsr	move_jack
	bsr	check_jack
	tst.w	jack_dead
	bne	\dead
	tst.w	d0
	beq	\skip
	cmp.w	#31,jack_goal
	blt	\dobonus

;winner !
\dolevel:
	move.w	last_level,d0
	cmp.w	level,d0
	beq	\victory
	bra	\loop1

\dead:	tst.w	jack_lives
	beq	\looser
	sub.w	#1,jack_lives
	bra	\loop2

\dobonus:
	sub.w	#1,bonus_left
	bsr	disp_remaining
	add.w	#3,jack_goal
	bsr	create_bonus
	bsr	put_bonus

\skip:	bsr	draw_jack

	move.w	delay,d3
	
\delay:	tst.w	(tios::kb_vars+$1C)
	bne	\keyhit
	dbf.w	d3,\delay
	bra	\loop

\keyhit:
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)

	move.w	jack_dir,d1
	cmp.w	#$108,d0
	beq	\abort
	cmp.w	#'8',d0
	beq	\up
	cmp.w	#$152,d0
	beq	\up
	cmp.w	#'5',d0
	beq	\down
	cmp.w	#$158,d0	
	beq	\down
	cmp.w	#'4',d0
	beq	\left
	cmp.w	#$151,d0
	beq	\left
	cmp.w	#'6',d0
	beq	\right
	cmp.w	#$154,d0
	beq	\right
	cmp.w	#'p',d0
	beq	\pause
	cmp.w	#'b',d0
	beq	\boss
	cmp.w	#275,d0
	beq	\cheat				;cheat = 2ND-F8
	bra	\loop

\cheat:	move.w	#1,jack_cheat
	bra	\dolevel

\up:	btst.w	#1,d1
	beq	\loop
	clr.w	jack_dir
	bra	\loop
\down:	btst.w	#1,d1
	beq	\loop
	move.w	#1,jack_dir
	bra	\loop
\left:	btst.w	#1,d1
	bne	\loop
	move.w	#2,jack_dir
	bra	\loop
\right:	btst.w	#1,d1
	bne	\loop
	move.w	#3,jack_dir
	bra	\loop
		
\boss:	trap	#4

\pause:	;bsr	getkey
	bsr	waitspace
	bra	\loop

\looser:
	bsr	clrscr
	WriteStr #1,#1,#1,m_looser
	bra	\end

\victory:
	bsr	clrscr
	tst.w	jack_cheat
	bne	\cheater
	WriteStr #1,#1,#1,m_winner
	bra	\end

\cheater:
	WriteStr #1,#1,#1,m_cheater
	bra	\end

\abort:	bsr	clrscr
	WriteStr #1,#1,#1,m_leave

\end:	bsr	waitspace
	bsr	exit
	rts

\error:	rts

buffer	dc.l	0
bhandle	dc.w	0

jackx		dcb.w	32,0
jacky		dcb.w	32,0				;errh,loosing 128 bytes
jack_dir	dc.w	0
jack_len	dc.w	2
jack_dead	dc.w	0
jack_goal	dc.w	0
jack_lives	dc.w	4
jack_cheat	dc.w	0

delay		dc.w	$2000
level		dc.w	0

bonus_left	dc.w	11
bonusx		dc.w	0
bonusy		dc.w	0

m_buffer	dc.b	"###########",0

m_title		dc.b	"NIBBLES, Freeware by Stilgar - 04.1997",0
m_title2        dc.b    "ported to Fargo II by G.Quri 01.1998",0
m_howtough	dc.b	"Enter Speed (0 lame - 9 tough !)",0
m_question	dc.b	"?_",0
m_winner	dc.b	"Well, you are a lucky winner !",0
m_looser	dc.b	"So, you are just another looser ?",0
m_leave		dc.b	"Scared ?",0
m_cheater	dc.b	"Oh no ! a winning cheater !",0

	include	levels.inc


_comment:
	dc.b	"Nibbles !",0


;;;;;;;;;;;;;;;;;;;;;;;;; End of Fargo program ;;;;;;;;;;;;;;;;;;;;;
	
	end
